/**
 * Not used.
 */
const DEFAULT_ANGLE_BETWEEN_CHANNEL_DEG = 2.5;

class Flatcone {

    constructor() {

        this._nbChannels = 31; //31 on existing flat cone
        this._angleBetweenChannel = Math.degToRad(this.defaultAngleBetweenChannelDeg());
        this._outsideRadius = 1.0;// SA+0.20m meter ; radius of the farthest side from sample
        this._insideRadius = 0.35; //meter ; radius of the closest side from sample
        this._finalWaveNumber = 1.4; // aka Kf
        this._activeChannel = 16; // between 0 and nbChannels-1
    }

    //TODO: Add File IO for reading and writing config as xml


    get nbChannels() {
        return this._nbChannels;
    }

    set nbChannels(value) {
        this._nbChannels = value;
    }

    get angleBetweenChannel() {
        return this._angleBetweenChannel;
    }

    set angleBetweenChannel(value) {
        this._angleBetweenChannel = value;
    }

    get outsideRadius() {
        return this._outsideRadius;
    }

    set outsideRadius(value) {
        this._outsideRadius = value;
    }

    get insideRadius() {
        return this._insideRadius;
    }

    set insideRadius(value) {
        this._insideRadius = value;
    }

    get finalWaveNumber() {
        return this._finalWaveNumber;
    }

    set finalWaveNumber(value) {
        this._finalWaveNumber = value;
    }

    get activeChannel() {
        return this._activeChannel;
    }

    set activeChannel(value) {
        this._activeChannel = value;
    }

    get defaultAngleBetweenChannelDeg(){
        return DEFAULT_ANGLE_BETWEEN_CHANNEL_DEG;
    }
}