/**
 * Not used.
 */
class Instrument {

    constructor(name, description, monochromator, analyser) {
        this._name = name;
        this._description = description;

        /** These will be taken from NOMAD*/
        this._lowerLimitA2 = 0;
        this._defaultA2 = 0;
        this._upperLimitA2 = 0;

        this._lowerLimitA4 = 0;
        this._defaultA4 = 0;
        this._upperLimitA4 = 0;

        this._lowerLimitA6 = 0;
        this._defaultA6 = 0;
        this._upperLimitA6 = 0;
        /** ^^^^^^These will be taken from NOMAD^^^^*/

        this._monochromator = monochromator
        this._analyser = analyser;

        //Area around the instrument
        this.walls;

        this._flatcone = null;

        if(this._flatcone != null){
            let d = 3.355; //for SI(111)
            let theta = Math.asin(Math.PI/(this._flatcone.finalWaveNumber() * d));
            this._fc_analyser = new DiffractionLattice(d, new Angle(theta));
        } else{
            this._fc_analyser = null;
        }



        /**
         * radius of the components rotate arc in meters.
         */
        this._sample_rotate_radius=1.0;
        this._analyser_rotate_radius=1.1;
        this._detector_rotate_radius=1.2;

        /**
         * radius of the sample table in meters.
         */
        this._sample_table_radius=0.3;

        /**
         * Scattering senses of the instrument
         */
        this._sm = 1;
        this._ss = 1;
        this._sa = 1;

    }

    //TODO
    exportToJSON() {
        JSON.stringify(this);
    }
    
    //TODO
    static createFromJSON() {

    }

    get name() {
        return this._name;
    }

    set name(value) {
        this._name = value;
    }

    get description() {
        return this._description;
    }

    set description(value) {
        this._description = value;
    }

    get lowerLimitA2() {
        return this._lowerLimitA2;
    }

    set lowerLimitA2(value) {
        this._lowerLimitA2 = value;
    }

    get defaultA2() {
        return this._defaultA2;
    }

    set defaultA2(value) {
        this._defaultA2 = value;
    }

    get upperLimitA2() {
        return this._upperLimitA2;
    }

    set upperLimitA2(value) {
        this._upperLimitA2 = value;
    }

    get lowerLimitA4() {
        return this._lowerLimitA4;
    }

    set lowerLimitA4(value) {
        this._lowerLimitA4 = value;
    }

    get defaultA4() {
        return this._defaultA4;
    }

    set defaultA4(value) {
        this._defaultA4 = value;
    }

    get upperLimitA4() {
        return this._upperLimitA4;
    }

    set upperLimitA4(value) {
        this._upperLimitA4 = value;
    }

    get lowerLimitA6() {
        return this._lowerLimitA6;
    }

    set lowerLimitA6(value) {
        this._lowerLimitA6 = value;
    }

    get defaultA6() {
        return this._defaultA6;
    }

    set defaultA6(value) {
        this._defaultA6 = value;
    }

    get upperLimitA6() {
        return this._upperLimitA6;
    }

    set upperLimitA6(value) {
        this._upperLimitA6 = value;
    }

    get flatcone() {
        return this._flatcone;
    }

    set flatcone(value) {
        this._flatcone = value;
    }

    get monochromator() {
        return this._monochromator;
    }

    set monochromator(value) {
        this._monochromator = value;
    }


    get analyser() {
        return this._analyser;
    }

    set analyser(value) {
        this._analyser = value;
    }

    get fc_analyser() {
        return this._fc_analyser;
    }

    set fc_analyser(value) {
        this._fc_analyser = value;
    }

    get sample_rotate_radius() {
        return this._sample_rotate_radius;
    }

    set sample_rotate_radius(value) {
        this._sample_rotate_radius = value;
    }

    get analyser_rotate_radius() {
        return this._analyser_rotate_radius;
    }

    set analyser_rotate_radius(value) {
        this._analyser_rotate_radius = value;
    }

    get detector_rotate_radius() {
        return this._detector_rotate_radius;
    }

    set detector_rotate_radius(value) {
        this._detector_rotate_radius = value;
    }

    get sample_table_radius() {
        return this._sample_table_radius;
    }

    set sample_table_radius(value) {
        this._sample_table_radius = value;
    }

    get sm() {
        return this._sm;
    }

    set sm(value) {
        this._sm = value;
    }

    get ss() {
        return this._ss;
    }

    set ss(value) {
        this._ss = value;
    }

    get sa() {
        return this._sa;
    }

    set sa(value) {
        this._sa = value;
    }
}