class MenuEvent {
    constructor() {
        if (this.constructor === MenuEvent) {
            throw new Error("Can't instantiate abstract class!");
        }
    }

    on(event, listener) {
        throw new Error("on must be redefined.");
    }

    dispatch(event, data) {
        throw new Error("dispatch must be redefined.");
    }
}

module.exports = MenuEvent;